#include <windows.h>
#include "resource.h"

/* =====================================
           C-Runtime Emulation
===================================== */
void* malloc(size_t size)
{
	return HeapAlloc(GetProcessHeap(), 0, size);
}

void* realloc(void* ptr, size_t size)
{
	return HeapReAlloc(GetProcessHeap(), 0, ptr, size);
}

void free(void* ptr)
{
	HeapFree(GetProcessHeap(), 0, ptr);
}

size_t strlen(const char* p)
{
	int i = 0;

	if(!p)
		return 0;

	while(*p++)
		i++;

	return i;
}

char* strcpy(char* p, const char *c)
{
	if(!p || !c || p == c)
		return 0;

	do
	{
		*(p++) = *c;
	}while(*(c++));

	return p;
}

char* strncpy(char* p, const char *c, size_t max)
{
	size_t i;

	if(!p || !c || p == c || !max)
		return 0;

	for(i = 0; i < max && *c; i++)
		*(p++) = *(c++);

	return p;
}

char* strcat(char* p, const char *c)
{
	if(!p || !c || p == c)
		return 0;

	p += strlen(p);	// NULLO܂Ő
	strcpy(p, c);		// strcpyB

	return p;
}

char* strncat(char* p, const char *c, size_t max)
{
	if(!p || !c || p == c || !max)
		return 0;

	p += strlen(p);	// NULLO܂Ő
	strncpy(p, c, max);		// strncpyB

	return p;
}
/* =====================================
        C-Runtime Emulation E N D
===================================== */

// t@CԂB^ꂽ̒̃|C^B
char* basename(const char* str)
{
	char* last = (char*)str;

	while(*str)
	{
		// ANSIȂB
		if(!IsDBCSLeadByte(*str) && *str == '\\')
			last = (char*)str + 1;
		str = CharNext(str);
	}

	return last;
}

/**************************************/

char* cmdline;

/**************************************/

BOOL CALLBACK MainDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static HICON appicon = NULL;

	switch(msg)
	{
	case WM_INITDIALOG:
		DragAcceptFiles(hWnd, TRUE);
		// Aboutǉ
		AppendMenu(GetSystemMenu(hWnd, FALSE), MF_SEPARATOR, 0, NULL);
		AppendMenu(GetSystemMenu(hWnd, FALSE), MF_STRING, 12345, "Appendɂ");

		// 
		if(*cmdline == '"')
		{
			cmdline++;
			*(cmdline + strlen(cmdline) - 1) = '\0';
		}
		ExtractIconEx(cmdline, 0, &appicon, NULL, 1);
		if(appicon)
			SendMessage(GetDlgItem(hWnd, IDC_EXEICON), STM_SETICON, (WPARAM)appicon, 0);

		return TRUE;	// set default focus
	case WM_CLOSE:
		if(appicon)
			DeleteObject(appicon);
		EndDialog(hWnd, 0);
		return TRUE;
	case WM_SYSCOMMAND:
		switch(wp)
		{
		case 12345:
			{
				char name[MAX_PATH + 1];
				char* vi;
				DWORD size;

				GetModuleFileName(NULL, name, MAX_PATH);
				size = GetFileVersionInfoSize(name, 0);
				if(vi = malloc(size))
				{
					GetFileVersionInfo(name, 0, size, vi);
					{
						VS_FIXEDFILEINFO* ver = (VS_FIXEDFILEINFO*)(vi + 40);
						
						// nameg
						wsprintf(name, "Append Version %d.%d.%d.%d", HIWORD(ver->dwFileVersionMS), LOWORD(ver->dwFileVersionMS),
							HIWORD(ver->dwFileVersionLS), LOWORD(ver->dwFileVersionLS));
						MessageBox(hWnd, name, "Appendɂ", MB_OK);
					}
					free(vi);
				}
			}
			return TRUE;
		}
		return FALSE;
	case WM_COMMAND:
		switch(LOWORD(wp))
		{
		case IDOK:
			{
				char* opt;
				int size = GetWindowTextLength(GetDlgItem(hWnd, IDC_OPTION)) + 1;

				if(!(opt = malloc(size)))
				{
					MessageBox(hWnd, "IvV擾obt@mێs", "G[", MB_ICONERROR | MB_OK);
				}else
				{
					GetDlgItemText(hWnd, IDC_OPTION, opt, size);
					ShellExecute(hWnd, NULL, cmdline, opt, NULL, SW_SHOW);
					free(opt);
				}
			}
			EndDialog(hWnd, 1);
			return TRUE;
		case IDCANCEL:
			EndDialog(hWnd, 0);
			return TRUE;
		case IDC_EXEICON:
			mciSendString("sound systemstart", NULL, 0, NULL);
			return FALSE;
		}
		break;
	case WM_DROPFILES:
		{
			HDROP hd = (HANDLE)wp;
			UINT i, max = DragQueryFile(hd, 0xFFFFFFFF, NULL, 0);
			char* bop, *aop;	// before, after.
			DWORD sel;
			int opsize;

			SendMessage(GetDlgItem(hWnd, IDC_OPTION), EM_GETSEL, (WPARAM)(&sel), 0);

			opsize = GetWindowTextLength(GetDlgItem(hWnd, IDC_OPTION));
			if(!(bop = malloc(opsize + 1)))
			{
				MessageBox(hWnd, "hbvꂽt@C擾ɃG[", "G[", MB_ICONERROR | MB_OK);
				break;	// I
			}
			GetDlgItemText(hWnd, IDC_OPTION, bop, opsize + 1);
			if(!(aop = malloc(opsize + 1)))
			{
				MessageBox(hWnd, "hbvꂽt@C擾ɃG[", "G[", MB_ICONERROR | MB_OK);
				free(bop);	// ߂ǂ
				break;	// I
			}
			strncpy(aop, bop, sel);
			*(aop + sel) = '\0';

			for(i = 0; i < max; i++)
			{
				char* file;
				UINT size = DragQueryFile(hd, i, NULL, 0) + 1;

				if(!(file = malloc(size)))
				{
					MessageBox(hWnd, "hbvꂽt@C擾ɃG[", "G[", MB_ICONERROR | MB_OK);
					free(bop);	// ߂ǂ
					free(aop);	// ߂ǂ
					break;	// I
				}

				if(!(aop = realloc(aop, opsize + size + 3 + 1)))
				{
					MessageBox(hWnd, "hbvꂽt@C擾ɃG[", "G[", MB_ICONERROR | MB_OK);
					free(bop);	// ߂ǂ
					free(file);	// ߂ǂ
					break;	// I
				}
				opsize += size - 1 + 3;

				DragQueryFile(hd, i, file, size);
				strcat(aop, "\"");
				strcat(aop, file);
				strcat(aop, "\" ");
				//MessageBox(hWnd, file, "", MB_OK);

				free(file);
			}

			strncat(aop, bop + sel, strlen(bop) - sel);
			*(aop + opsize) = '\0';

			SetDlgItemText(hWnd, IDC_OPTION, aop);

			free(aop);
			free(bop);

			DragFinish(hd);

			SetFocus(GetDlgItem(hWnd, IDC_OPTION));
			SetForegroundWindow(hWnd);
			SetFocus(hWnd);
		}
		break;
	}
	return FALSE;
}

void regist(void)
{
	HKEY hk;
	char val[80];
	LONG size = sizeof(val);

	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, NULL, 0, KEY_READ, &hk) != ERROR_SUCCESS)
	{
		MessageBox(NULL, "WXgI[vs", "G[", MB_ICONERROR | MB_OK);
		return;
	}

	if(RegQueryValue(hk, ".exe\\", val, &size) != ERROR_SUCCESS)
	{
		MessageBox(NULL, "WXg[hs", "G[", MB_ICONERROR | MB_OK);
		return;
	}

	RegCloseKey(hk);	// G[Ȃ...

	strcat(val, "\\shell\\append");

	// exefile\shell\appendJĂ݂
	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, val, 0, KEY_READ, &hk) != ERROR_SUCCESS)
	{
		// Ȃ->N
		if(MessageBox(NULL, "Appendo^܂?", "", MB_ICONQUESTION | MB_YESNO) == IDYES)
		{
			char tmp[MAX_PATH + 1];
			char v[MAX_PATH + 1];

			if(RegCreateKeyEx(HKEY_CLASSES_ROOT, val, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hk, NULL) != ERROR_SUCCESS)
			{
				MessageBox(NULL, "WXgI[vs", "G[", MB_ICONERROR | MB_OK);
				return;
			}
			strcpy(v, "IvVw肵Ďs");
			RegSetValueEx(hk, "", 0, REG_SZ, v, strlen(v) + 1);
			RegCloseKey(hk);

			strcat(val, "\\command");
			if(RegCreateKeyEx(HKEY_CLASSES_ROOT, val, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hk, NULL) != ERROR_SUCCESS)
			{
				MessageBox(NULL, "WXgI[vs", "G[", MB_ICONERROR | MB_OK);
				return;
			}

			strcpy(v, "\"");
			GetModuleFileName(NULL, tmp, MAX_PATH);
			strcat(v, tmp);
			strcat(v, "\" \"%l\"");
			RegSetValueEx(hk, "", 0, REG_SZ, v, strlen(v) + 1);
			RegCloseKey(hk);
		}
	}else{
		// ->o^Ă
		RegCloseKey(hk);

		if(MessageBox(NULL, "Append͂łɓo^Ă悤łB\nAppendo^܂?", "", MB_ICONQUESTION | MB_YESNO) == IDYES)
		{
			*(basename(val) - 1) = '\0';
			if(RegOpenKeyEx(HKEY_CLASSES_ROOT, val, 0, KEY_READ, &hk) != ERROR_SUCCESS)
			{
				MessageBox(NULL, "WXgI[vs", "G[", MB_ICONERROR | MB_OK);
				return;
			}
			if(RegDeleteKey(hk, "append\\command") != ERROR_SUCCESS)
				MessageBox(NULL, "WXg폜s", "G[", MB_ICONERROR | MB_OK);
			if(RegDeleteKey(hk, "append") != ERROR_SUCCESS)
				MessageBox(NULL, "WXg폜s", "G[", MB_ICONERROR | MB_OK);
			RegCloseKey(hk);
		}
	}

	return;
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	cmdline = GetCommandLine();

	if(*cmdline == '"')
	{
		for(cmdline++; *cmdline && *cmdline != '"'; cmdline++)
			;
		if(*++cmdline)
			cmdline ++;
	}else
	{
		for(cmdline++; *cmdline && *cmdline != ' '; cmdline++)
			;
		if(*cmdline)
			cmdline++;
	}

	if(!strlen(cmdline))
		regist();
	else
		DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, MainDlgProc, 0);

	ExitProcess(0);
}
